// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/GameStateBase.h"
#include "TurnBaseCombat.generated.h"

/**
 *
 */
UCLASS()
class THE_TWILIGHT_ABYSS_API ATurnBaseCombat : public AGameStateBase
{
	GENERATED_BODY()

public:
	ATurnBaseCombat() = default;

	UPROPERTY(EditDefaultsOnly)
		int playerHealth = 100;
	UPROPERTY(EditDefaultsOnly)
		int enemyHealth = 100;
	UPROPERTY(EditDefaultsOnly)
		int defaultActionPoints = 3;
	int activeActionPoints = 0;

	AActor* playerActor;
	AActor* enemyActor;
	AActor* activeActor;

	/*
	TODO:
	Reference Blueprint HUD
	Reference Action Library
	Reference Player Inventory 
	Reference Combat Logging System
	*/

protected:
	virtual void BeginPlay() override;
	void useActionPoint();
	void reuseActionPoint();
	void revertActionPoints();

private:
	UPROPERTY(EditDefaultsOnly)
		bool isPlayerTurn = true;
	void switchTurn();
};
